local old_set_laser_enabled = NPCRaycastWeaponBase.set_laser_enabled
local old_destroy = NPCRaycastWeaponBase.destroy
local old_set_visibility = NPCRaycastWeaponBase.set_visibility_state

function NPCRaycastWeaponBase:set_laser_enabled(state, custom_color)
	local ret = old_set_laser_enabled(self, state)
	if state and custom_color then
		self._laser_unit:base():set_color(custom_color)
	end
	return ret
end

function NPCRaycastWeaponBase:destroy(unit)
	if self.set_laser_enabled then
		self:set_laser_enabled(false)
	end
	return old_destroy(self, unit)
end

function NPCRaycastWeaponBase:set_visibility_state(state)
	if not state and self.set_laser_enabled then
		self:set_laser_enabled(false)
	end
	return old_set_visibility(self, state)
end